apeman-scaffold
==========

<!-- Badge Start -->
<a name="badges"></a>

[![Build Status][bd_travis_shield_url]][bd_travis_url]
[![Code Climate][bd_codeclimate_shield_url]][bd_codeclimate_url]
[![Code Coverage][bd_codeclimate_coverage_shield_url]][bd_codeclimate_url]
[![Dependency Status][bd_gemnasium_shield_url]][bd_gemnasium_url]
[![npm Version][bd_npm_shield_url]][bd_npm_url]

[bd_repo_url]: https://github.com/apeman-labo/apeman-scaffold
[bd_travis_url]: http://travis-ci.org/apeman-labo/apeman-scaffold
[bd_travis_shield_url]: http://img.shields.io/travis/apeman-labo/apeman-scaffold.svg?style=flat
[bd_license_url]: https://github.com/apeman-labo/apeman-scaffold/blob/master/LICENSE
[bd_codeclimate_url]: http://codeclimate.com/github/apeman-labo/apeman-scaffold
[bd_codeclimate_shield_url]: http://img.shields.io/codeclimate/github/apeman-labo/apeman-scaffold.svg?style=flat
[bd_codeclimate_coverage_shield_url]: http://img.shields.io/codeclimate/coverage/github/apeman-labo/apeman-scaffold.svg?style=flat
[bd_gemnasium_url]: https://gemnasium.com/apeman-labo/apeman-scaffold
[bd_gemnasium_shield_url]: https://gemnasium.com/apeman-labo/apeman-scaffold.svg
[bd_npm_url]: http://www.npmjs.org/package/apeman-scaffold
[bd_npm_shield_url]: http://img.shields.io/npm/v/apeman-scaffold.svg?style=flat
[bd_bower_badge_url]: https://img.shields.io/bower/v/apeman-scaffold.svg?style=flat

<!-- Badge End -->


<!-- Description Start -->
<a name="description"></a>

Project scaffolding tool.

<!-- Description End -->


<!-- Overview Start -->
<a name="overview"></a>

Overview
--------

apeman-scaffold helps you to generate an apeman project structure for quick start.

 There are [official scaffold plugins][scaffold_labo_url] supported by apeman team.
 
 [scaffold_labo_url]: https://github.com/apeman-scaffold-labo

<!-- Overview End -->


<!-- Sections Start -->
<a name="sections"></a>

<!-- Section from "doc/readme/01.Installation.md.hbs" Start -->

<a name="section-doc-readme-01-installation-md"></a>
Installation
-----

```bash
$ npm install apeman-scaffold -g
```

<!-- Section from "doc/readme/01.Installation.md.hbs" End -->

<!-- Section from "doc/readme/02.Usage.md.hbs" Start -->

<a name="section-doc-readme-02-usage-md"></a>
Usage
---------


```bash
$ apeman-scaffold web my-awesome-project
```


#### CLI Options

```bash
$ apeman-scaffold -h

  Usage: apeman-scaffold|sc [options] [type] [dest] 

  Generate project scaffold.

  Options:

    -h, --help      output usage information
    -V, --version   output the version number
    -t, --straight  Scaffold without asking.
    -s, --silent    Disable console logs
    -f, --force     Force to generate scaffold


```

#### Available Types

+ app
+ bud
+ command
+ plain
+ scaffold
+ tmpl
+ react
+ task
+ web

<!-- Section from "doc/readme/02.Usage.md.hbs" End -->

<!-- Section from "doc/readme/03.Programmatic API.md.hbs" Start -->

<a name="section-doc-readme-03-programmatic-a-p-i-md"></a>
Programmatic API
---

apeman-scaffold also provide programmatic API.

Firstly, install the module locally.

```bash
$ npm install apeman-scaffold --save-dev
```

Then,

```javascript
var apemanScaffold = require('apeman-scaffold');

// Generate a project with "plain" template.
apemanScaffold('plain', '~/project/my-awesome-project', {

}, function(err){
    /*...*/
});
```


#### Programmatic Options

| Key | Description | Default |
| --- | ----------- | ------- |
| straight | Scaffold without asking. |  |
| silent | Disable console logs |  |
| force | Force to generate scaffold |  |

<!-- Section from "doc/readme/03.Programmatic API.md.hbs" End -->

<!-- Section from "doc/readme/04.Contributing.md.hbs" Start -->

<a name="section-doc-readme-04-contributing-md"></a>
Contribution
------
You can create your own task plugin quickly with scaffold.
Install [apeman-scaffold][scaffold_url] as a global module
```bash
$ npm install apeman-scaffold -g
```
then, generate scaffold.
```bash
$ apeman-scaffold scaffold apeman-scaffold-yourown
```
[scaffold_url]: https://www.npmjs.com/package/apeman-scaffold
<!-- Section from "doc/readme/04.Contributing.md.hbs" End -->


<!-- Sections Start -->


<!-- LICENSE Start -->
<a name="license"></a>

License
-------
This software is released under the [MIT License](https://github.com/apeman-labo/apeman-scaffold/blob/master/LICENSE).

<!-- LICENSE End -->


<!-- Links Start -->
<a name="links"></a>

Links
------

+ [apeman](https://github.com/apeman-labo/apeman)
+ [apeman-scaffold-labo](https://github.com/apeman-scaffold-labo)

<!-- Links End -->
