/**
 * Apply a scaffold.
 * @memberof module:apeman-scaffold/lib/scaffold
 * @function applyScaffold
 */

"use strict";

var async = require('async'),
    extend = require('extend'),
    tmplconv = require('tmplconv'),
    filemode = require('filemode');

/** @lends applyScaffold */
function applyScaffold(type, dest, asked, options, callback) {
    async.series([
        function (callback) {
            var config = extend({}, {}, asked);
            tmplconv.render(type.tmpl, dest, {
                prefix: type.prefix,
                suffix: type.suffix,
                pattern: type.pattern,
                silent: options.silent,
                clean: false,
                once: false,
                data: config
            }, callback);
        },
        function (callback) {
            filemode(type.mode || {}, {
                cwd: dest
            }, callback);
        }
    ], callback);
}

module.exports = applyScaffold;
