/**
 * Ask configs for scaffold.
 * @memberof module:apeman-scaffold/lib/scaffold
 * @function askScaffold
 */

"use strict";

var evaljson = require('evaljson'),
    gitconfig = require('gitconfig'),
    extend = require('extend'),
    path = require('path'),
    askconfig = require('askconfig');

/** @lends askScaffold */
function askScaffold(type, dest, options, callback) {
    var config = evaljson(type.ask, {
        gitUser: extend({
            name: "__user_name__",
            email: "__user_email__",
            url: ""
        }, gitconfig.get.sync('user')),
        dirname: path.basename(dest)
    });
    if (options.straight) {
        callback(null, config);
    } else {
        askconfig(config, callback);
    }
}

module.exports = askScaffold;
